# HCOMBINE - Combine merged images, removing cosmic rays in the process
# July 20, 2004
# By Doug Mink, SAO Telescope Data Center

procedure hcombine (images, output)

string	images=""	{prompt="Images to combine"}
file	output=""	{prompt="Output image"}
string	combine = "average"	{prompt="Combine images (average|median|sum)"}
string	reject = "none"	{prompt="Reject method (none|minmax|ccdclip|crreject|sigclip|avsigclip|pclip)"}
bool	saveold = yes	{prompt="Save uncombined files in Uncombined/ (y or n)"}
bool	verbose = yes	{prompt="Print process progress (y or n)"}

begin

int	ifile, nfiles, lname, lroot
string	iml, tchar, iml1, imagelist, cleanlist, imageroot, imagej
string	extxt, combim, rejim, expression, imin, coslist, history
file	tempmed, tempdiff, tempbad, tempsig, imagei, listfile, imageout, imfile
file	rejfile, secfile, tempnsig, newfile
real	medmed, medi, factor, basemed
bool	dellist, vb, basefile, newmed

	vb = verbose
	imagelist = images
	imageout = output
	rejim = reject
	combim = combine

# Initialize imcombine
	combine.headers = ""
	combine.bpmasks = ""
	combine.nrejmasks = ""
	combine.expmasks = ""
	combine.sigmas = ""
	combine.ccdtype = ""
	combine.amps = no
	combine.subsets = no
	combine.delete = no
	combine.combine = "median"
	combine.reject = "none"
	combine.project = no
	combine.outtype = "real"
	combine.outlimits = ""
	combine.offsets = "none"
	combine.masktype = "none"
	combine.maskvalue = 0.
	combine.blank = 0.
	combine.scale = "none"
	combine.zero = "none"
	combine.weight = "none"
	combine.statsec = ""
	combine.lthreshold = INDEF
	combine.hthreshold = INDEF
	combine.nlow = 1
	combine.nhigh = 1
	combine.nkeep = 1
	combine.mclip = yes
	combine.lsigma = 3.
	combine.hsigma = 3.
	combine.rdnoise = "0."
	combine.gain = "1."
	combine.snoise = "0."
	combine.sigscale = 0.1
	combine.pclip = -0.5
	combine.grow = 0.

# Sum images
	combine.combine = combim
	combine.reject = rejim
	if (vb) {
	    print ("HCOMBINE: Combined file ", imageout)
	    }
	combine.outtype="real"
	combine.rejmasks = ""
	combine (imagelist, imageout)
end

# Mar 18 2005	New program, based on hcombine2.cl
