# File hectospec/Src/t_smatch.x
# May 12, 2005
# By Doug Mink, Harvard-Smithsonian Center for Astrophysics

# SMATCH -- return 1 if pattern is found in string, else 0

include <ctype.h>

int procedure t_smatch()

char	tstring[SZ_LINE], pattern[SZ_LINE]
int	i, strmatch(), strlen()
bool	found, verbose, length, clgetb()

begin
	verbose = clgetb ("verbose")

	call clgstr ("string", tstring, SZ_LINE)
	call clgstr ("pattern", pattern, SZ_LINE)
	if (strlen (pattern) < 1) {
	    i = strlen (pattern)
	    length = TRUE
	    }
	else {
	    i = strmatch (tstring, pattern) - strlen (pattern)
	    length = FALSE
	    }
	call clputi ("start",i)
	if (i <= 0)
	    found = FALSE
	else
	    found = TRUE
	call clputb ("found",found)
	if (verbose) {
	    if (found && length) {
		if (i > 1) {
		    call printf ("SMATCH: %s is %d characters long\n")
			call pargstr (tstring)
			call pargi (i)
		    }
		else {
		    call printf ("SMATCH: %s is 1 character long\n")
			call pargstr (tstring)
		    }
		}
	    else if (found) {
		call printf ("SMATCH: found %s in %s at %d\n")
		    call pargstr (pattern)
		    call pargstr (tstring)
		    call pargi (i)
		}
	    else {
		call printf ("SMATCH: could not find %s in %s\n")
		    call pargstr (pattern)
		    call pargstr (tstring)
		}
	    }
	return
end
# Feb 16 1995	New task

# Jul 13 1998	Write position of first matched character to parameter

# Jun 15 1999	Fix bug which always returned matches

# May 12 2005	If pattern is null string, return length of string
